
; FASM SOURCE FILE
; http://flatassembler.net

; Ring-0 Procedure Call & Direct Port I/O
; import sections

; written by @L.CHEMIST (Andrey A. Meshkov)
; http://maalchemist.narod.ru
; maalchemist@yandex.ru
; maalchemist@gmail.com

; ------------------------------------------------------------------------------

section '.rdata' data readable notpageable

IAT     ntoskrnl,\
        IoIs32bitProcess,\
        RtlInitUnicodeString,\
        RtlCopyUnicodeString,\
        RtlFillMemory,\
        RtlZeroMemory,\
        RtlCopyMemory,\
        RtlMoveMemory,\
        RtlCompareMemory,\
        IoCreateDevice,\
        IoDeleteDevice,\
        IoCreateSymbolicLink,\
        IoDeleteSymbolicLink,\
        IoCompleteRequest,\
        IofCompleteRequest,\
        ExAllocatePoolWithTag,\
        ExFreePoolWithTag,\
        MmIsAddressValid,\
        MmMapIoSpace,\
        MmUnmapIoSpace,\
        memset,\
        memcpy,\
        memcmp,\
        KeSetEvent,\
        KePulseEvent,\
        KeClearEvent,\
        KeReadStateEvent,\
        KeWaitForSingleObject,\
        ZwClose,\
        ObDereferenceObject,\
        IoCreateNotificationEvent,\
        IoCreateSynchronizationEvent,\
        PsInitialSystemProcess,\
        PsGetCurrentProcessId,\
        PsLookupProcessByProcessId,\
        PsSetLoadImageNotifyRoutine,\
        PsRemoveLoadImageNotifyRoutine,\
        PsSetCreateProcessNotifyRoutine

; ------------------------------------------------------------------------------

section 'INIT' data import readable notpageable

library ntoskrnl, 'ntoskrnl.exe'

import  ntoskrnl,\
        IoIs32bitProcess, 'IoIs32bitProcess',\
        RtlInitUnicodeString, 'RtlInitUnicodeString',\
        RtlCopyUnicodeString, 'RtlCopyUnicodeString',\
        RtlFillMemory, 'RtlFillMemory',\
        RtlZeroMemory, 'RtlZeroMemory',\
        RtlCopyMemory, 'RtlCopyMemory',\
        RtlMoveMemory, 'RtlMoveMemory',\
        RtlCompareMemory, 'RtlCompareMemory',\
        IoCreateDevice, 'IoCreateDevice',\
        IoDeleteDevice, 'IoDeleteDevice',\
        IoCreateSymbolicLink, 'IoCreateSymbolicLink',\
        IoDeleteSymbolicLink, 'IoDeleteSymbolicLink',\
        IoCompleteRequest, 'IoCompleteRequest',\
        IofCompleteRequest, 'IofCompleteRequest',\
        ExAllocatePoolWithTag, 'ExAllocatePoolWithTag',\
        ExFreePoolWithTag, 'ExFreePoolWithTag',\
        MmIsAddressValid, 'MmIsAddressValid',\
        MmMapIoSpace, 'MmMapIoSpace',\
        MmUnmapIoSpace, 'MmUnmapIoSpace',\
        memset, 'memset',\
        memcpy, 'memcpy',\
        memcmp, 'memcmp',\
        KeSetEvent, 'KeSetEvent',\
        KePulseEvent, 'KePulseEvent',\
        KeClearEvent, 'KeClearEvent',\
        KeReadStateEvent, 'KeReadStateEvent',\
        KeWaitForSingleObject, 'KeWaitForSingleObject',\
        ZwClose, 'ZwClose',\
        ObDereferenceObject, 'ObDereferenceObject',\
        IoCreateNotificationEvent, 'IoCreateNotificationEvent',\
        IoCreateSynchronizationEvent, 'IoCreateSynchronizationEvent',\
        PsInitialSystemProcess, 'PsInitialSystemProcess',\
        PsGetCurrentProcessId, 'PsGetCurrentProcessId',\
        PsLookupProcessByProcessId, 'PsLookupProcessByProcessId',\
        PsSetLoadImageNotifyRoutine, 'PsSetLoadImageNotifyRoutine',\
        PsRemoveLoadImageNotifyRoutine, 'PsRemoveLoadImageNotifyRoutine',\
        PsSetCreateProcessNotifyRoutine, 'PsSetCreateProcessNotifyRoutine'

; ------------------------------------------------------------------------------
