ECHO OFF

set FASM=%ProgramFiles%\FASM\FASM.EXE
set INCLUDE=%ProgramFiles%\FASM\INCLUDE


rem *** BUILD
"%FASM%" RZ32.ASM -m 65536
"%FASM%" RZ32LC.ASM -m 65536
"%FASM%" RZ32ZD.ASM -m 65536

rem *** SIGN
set cn=maalchemist@yandex.ru
set sn=maalchemist@yandex.ru

signtool sign /a /v /s "%sn%" /n "%cn%" RZ32.SYS
signtool sign /a /v /s "%sn%" /n "%cn%" RZ32LC.SYS
signtool sign /a /v /s "%sn%" /n "%cn%" RZ32ZD.SYS

rem *** COPY
copy RZ32.SYS ..\TEST\FASM\RZ32.SYS
copy RZ32.SYS ..\TEST\DELPHI\BIN\RZ32.SYS
copy RZ32.SYS ..\TEST\DELPHI\BIN\Win32\RZ32.SYS
copy RZ32.SYS ..\TEST\DELPHI\BIN\Win64\RZ32.SYS

pause
