
; FASM SOURCE FILE
; http://flatassembler.net

; Ring-0 Procedure Call & Direct Port I/O (64-BIT)
; main project file

; written by @L.CHEMIST (Andrey A. Meshkov)
; http://maalchemist.narod.ru
; maalchemist@yandex.ru
; maalchemist@gmail.com

; thanks to AMD64 for KMD.inc
; http://board.flatassembler.net/viewtopic.php?t=648
; http://board.flatassembler.net/download.php?id=297

; thanks to Ms-Rem for some ideas
; http://wasm.ru/print.php?article=apihook_1
; http://wasm.ru/print.php?article=apihook_2
; http://wasm.ru/print.php?article=apihook_3

; thanks to Feryno for remarks on import section

RZ64ZD:

; ------------------------------------------------------------------------------

RS_Description EQU 'Ring-0 Procedure Call & Direct Port I/O (64-BIT) :: skyDSuite'
RS_Version     EQU '1.1.0.6'
RS_Filename    EQU 'RZ64ZD.SYS'
RS_Company     EQU 'AL-CHEMIST GUILD'
RS_Copyright   EQU 'Copyright  2000-3000 AL-CHEMIST GUILD'

RS_WWW         EQU 'http://maalchemist.narod.ru',13,10,\
                   'http://maalchemist.flybb.ru'
RS_Email       EQU 'maalchemist@yandex.ru',13,10,\
                   'maalchemist@gmail.com'

; WebMoney
RS_WMR         EQU 'R388235483201'
RS_WME         EQU 'E038486814864'
RS_WMZ         EQU 'Z798041863268'

; Yandex.Money
RS_YM          EQU '41001481909297'

; ------------------------------------------------------------------------------

SC_DEVICE      EQU '\Device\RZ64ZD'
SC_SBLINK      EQU '\DosDevices\RZ64ZD'

SC_EVENT_CP    EQU '\BaseNamedObjects\Global\RZ64ZD.Event.CreateProcess'
SC_EVENT_CPC   EQU '\BaseNamedObjects\Global\RZ64ZD.Event.CreateProcessCallback'
SC_EVENT_CPG   EQU '\BaseNamedObjects\Global\RZ64ZD.Event.CreateProcessGet'

; ------------------------------------------------------------------------------

format PE64 DLL native 5.02 at 10000h
entry dzentry

DEFINE    _X64  TRUE
DEFINE  _WIN64  TRUE
DEFINE UNICODE FALSE

; ------------------------------------------------------------------------------

include 'RZ64.INC'

; ------------------------------------------------------------------------------

section '.text' code readable executable notpageable
include '.TEXT64.ASM'

; ------------------------------------------------------------------------------

; section '.data' data readable writeable notpageable
include '..\xCommon\.DATA.ASM'

; ------------------------------------------------------------------------------

; section '.rdata' data readable notpageable
; section 'INIT' data import readable notpageable
include '..\xCommon\.IAT.INC'

; ------------------------------------------------------------------------------

; section '.rsrc' resource data readable
include '..\xCommon\.RSRC.INC'

; ------------------------------------------------------------------------------

section '.reloc' fixups data readable discardable

; ------------------------------------------------------------------------------
